default:
  before_script:
    # Whatever the name of the job (such as mdbook or generic-cyt) we will change to that directory
    # This would be the location of the Dockerfile used later to build the docker image.
    - cd $CI_JOB_NAME
    - docker login -u $CI_REGISTRY_USER -p $CI_REGISTRY_PASSWORD $CI_REGISTRY

generic-cyt:
  image: docker:latest
  variables:
    FULL_NAME: $CI_REGISTRY_IMAGE/$CI_JOB_NAME
  stage: deploy
  services:
    - docker:dind
  script:
    # Grab rebuild to the latest image using the Dockerfile in /generic-cyt
    - docker build --pull -t $FULL_NAME .
    - docker tag $FULL_NAME:latest $FULL_NAME:$CI_COMMIT_SHORT_SHA
    - docker push $FULL_NAME
  rules:
    - if: $CI_COMMIT_BRANCH == "master"
      changes:
      - generic-cyt/*


# django-rf:
#   image: docker:latest
#   variables:
#     FULL_NAME: $CI_REGISTRY_IMAGE/$CI_JOB_NAME
#   stage: deploy
#   services:
#     - docker:dind
#   script:
#     - docker build --pull -t $FULL_NAME .
#     - docker tag $FULL_NAME:latest $FULL_NAME:$CI_COMMIT_SHORT_SHA
#     - docker push $FULL_NAME
#   rules:
#     - if: $CI_COMMIT_BRANCH == "master"
#       changes:
#       - django-rf/*

# exam-provisioning-system:
#   image: docker:latest
#   variables:
#     FULL_NAME: $CI_REGISTRY_IMAGE/$CI_JOB_NAME
#   stage: deploy
#   services:
#     - docker:dind
#   script:
#     - docker build --pull -t $FULL_NAME .
#     - docker tag $FULL_NAME:latest $FULL_NAME:$CI_COMMIT_SHORT_SHA
#     - docker push $FULL_NAME
#   rules:
#     - if: $CI_COMMIT_BRANCH == "master"
#       changes:
#       - exam-provisioning-system/*

basic-dev:
  image: docker:latest
  variables:
    FULL_NAME: $CI_REGISTRY_IMAGE/$CI_JOB_NAME
  stage: deploy
  services:
    - docker:dind
  script:
    - docker build --pull -t $FULL_NAME .
    - docker tag $FULL_NAME:latest $FULL_NAME:$CI_COMMIT_SHORT_SHA
    - docker push $FULL_NAME
  rules:
    - if: $CI_COMMIT_BRANCH == "master"
      changes:
      - basic-dev/*

ccd-vscode-server:
  image: docker:latest
  variables:
    FULL_NAME: $CI_REGISTRY_IMAGE/$CI_JOB_NAME
  stage: deploy
  services:
    - docker:dind
  script:
    - docker build --pull -t $FULL_NAME .
    - docker tag $FULL_NAME:latest $FULL_NAME:$CI_COMMIT_SHORT_SHA
    - docker push $FULL_NAME
  rules:
    - if: $CI_COMMIT_BRANCH == "master"
      changes:
      - ccd-vscode-server/*
    
mdbook:
  image: docker:latest
  variables:
    FULL_NAME: $CI_REGISTRY_IMAGE/$CI_JOB_NAME
  stage: deploy
  services:
    - docker:dind
  script:
    - docker build --pull -t $FULL_NAME .
    - docker tag $FULL_NAME:latest $FULL_NAME:$CI_COMMIT_SHORT_SHA
    - docker push $FULL_NAME
  rules:
    - if: $CI_COMMIT_BRANCH == "master"
      changes:
      - mdbook/*

test-asset-service:
  image: docker:latest
  variables:
    FULL_NAME: $CI_REGISTRY_IMAGE/$CI_JOB_NAME
  stage: deploy
  services:
    - docker:dind
  script:
    - docker build --pull -t $FULL_NAME .
    - docker tag $FULL_NAME:latest $FULL_NAME:$CI_COMMIT_SHORT_SHA
    - docker push $FULL_NAME
  rules:
    - if: $CI_COMMIT_BRANCH == "master"
      changes:
      - test-asset-service/*
